var faves_coop = Components.classes['@flock.com/singleton;1'].getService(Components.interfaces.flockISingleton).getSingleton('chrome://browser/content/flock/common/load-faves-coop.js').wrappedJSObject;

function loadIt() {

  addBox('col1','<div class="content">When you need to search, you can our search widget - it\'s at top right corner of the browser.</div>', 'Learn The Flock')
  addBox('col1',mediaBox(), 'New Media')
  

  var feeds = faves_coop.Feed.all();
  var count=1;
  while (feeds.hasMoreElements()) {
    var feed = feeds.getNext()
    count++;
    if (count%2) {
      var col = 'col2';
    } else {
      var col = 'col3';
    }
    addBox(col, feedBox(feed), '<img src="'+(feed.favicon || 'http://flock.com/favicon.ico') +'"/> New items for ' + feed.name )
  }
}

function accountBox() {
  var box = document.createElement('div')
  box.setAttribute('class','content')
  
  var enum = faves_coop.Account.all()
  if (enum.hasMoreElements()) {
    while (enum.hasMoreElements()) {
      var account = enum.getNext()
      var row = document.createElement('p')
      row.innerHTML = '<img src="'+ account.favicon + '"/> ' + account.name
      row.onclick = function () {
        window.location.href = account.URL;
      }
      row.setAttribute('style', 'cursor: pointer')
      box.appendChild(row)
    }
    return box
  } else {
    box.innerHTML = "Flock makes sites like <a href='http://myspace.com'>myspace</a> and <a href='http://flickr.com'>flickr</a> better.  When you sign into them, flock will enhance your experience"
    return box
  }
}

function feedBox(feed) {
  // return a document node containing all the unseen items in a feed
  // if there are non, return null
  
  var box = document.createElement('div')
  box.setAttribute('class','content')
  
  var enum = feed.children.enumerateBackwards()
  var count = 0;
  while (enum.hasMoreElements() && count < 5) {
    var item = enum.getNext();
    if (item.unseen) {
      count++;
      var row = document.createElement('p')
      var a = document.createElement('a')
      a.innerHTML = item.name
      a.item = item;
      a.href = item.URL;
      a.onclick = function() {
        this.item.unseen = false
      }
      row.appendChild(a)
      box.appendChild(row)
    }
  }
  if (count > 0)
  return box
}

function mediaBox() {
  // return a document node containing all the unseen items in a feed
  // if there are non, return null
  
  var box = document.createElement('div')
  box.setAttribute('class','content')
  var enum = faves_coop.MediaQuery.all();
  var count = 0;
  while (enum.hasMoreElements() && count < 5) {
    var item = enum.getNext();
    if (item.hasUnseenItems) {
      count++;
      var row = document.createElement('p')
      var a = document.createElement('a')
      var img = document.createElement('img');
      img.setAttribute('src', item.favicon);
      a.appendChild(img)
      a.appendChild(document.createTextNode(item.name));
      a.item = item;
      a.onclick = function(e) {
        // using WM since I couldn't figure out how to do something like top.contentOwner... - ja
        var nav = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                            .getService(Components.interfaces.nsIWindowMediator)
                            .getMostRecentWindow("navigator:browser")
        nav.mediabar.loadQuery(this.item.service, this.item.query, this.item.name );
      }
      row.appendChild(a)
      box.appendChild(row)
    }
  }
  if (count > 0)
  return box
}


function addBox(column, box, title) {
  // add the box to the html page, unless the box is null
  // in which case skip it
  if (!box) return;
  var div = document.createElement('div')
  var span = document.createElement('span')
  span.setAttribute('class', 'title')
  span.innerHTML = title;
  if (typeof box == 'string') {
    div.innerHTML = box;
    div.insertBefore( span, div.childNodes[0] );
  } 
  else {
    div.appendChild(span)
    div.appendChild(box);
  }
  div.setAttribute('class', 'box');
  document.getElementById(column).appendChild(div)
  span.onclick = function() {
    if (this.nextSibling.style.display == 'none') {
      this.nextSibling.style.display = 'block';
    } else {
      this.nextSibling.style.display = 'none';
    }
  }
}

window.onload = loadIt;
